var DEF_WASM_PATH = '/js/datasymbol-sdk.wasm';
var viewPortId = 'datasymbol-barcode-viewport';
var barcodeToDecode = ['EAN13', 'UPCA', 'Code128', 'Code39', 'DataMatrix', 'QRCode', 'QRCodeUnrecognized'];

function onBarcodeReady (barcodeResult) {
    var barDataEl = document.getElementById('status');

	for (var i = 0; i < barcodeResult.length; ++i) {
	        var sBarcode = DSScanner.bin2String(barcodeResult[i]);
	        var sPoints = "";
	        for (var j = 0; j < 4; j++)
	            sPoints += "(" + barcodeResult[i].points[j].x + ", " + barcodeResult[i].points[j].y + "),";

	        barDataEl.innerHTML = barcodeResult[i].type + ": " + sBarcode + "|" + sPoints;
	        console.log(barDataEl.innerHTML);
    }
};

function onError(err) {
    var statusElement = document.getElementById('status');
    statusElement.innerHTML = 'Error: ' + err.message;

    /*
    if(err.name == 'NotFoundError')
        alert('no camera');
    else if(err.name == 'PermissionDeniedError')
        alert('camera permission denied');
    else if(err.name == 'NotCompatibleBrowser')
        alert('browser err');
    else if(err.name == 'ModuleAbort')
        alert('module err');
    else if(err.name == 'CannotInitLib')
        alert('Cannot initialize barcode decoder SDK');
    */
}

function CreateScanner(device){
	var barDataEl = document.getElementById( viewPortId );
	if( barDataEl == null )
		return;

	var bMobile = /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent);

	var scannerSettings = {
		scanner: {
			key: '',
			frameTimeout:	100,
			barcodeTimeout:	1000,
			beep: true,
		},
		viewport: {
			id: viewPortId,
			width: bMobile ? null : 640,	//null means 100% width
			//height: 200,
		},
		camera: {
			id: device ? device.id : null,
			label: device ? device.label : null,
			resx: 640,
			resy: 480,
		},
		barcode: {
			barcodeTypes: barcodeToDecode,
			bQRCodeFindMicro: false,
			frameTime: 200,
		},
	};

	if(bMobile){
		scannerSettings.camera.facingMode = 'environment';
	}
	else{
		scannerSettings.camera.id = device ? device.id : null;
		scannerSettings.camera.label = device ? device.label : null;
	}

	DSScanner.addEventListener('onError', onError);
	DSScanner.addEventListener('onBarcode', onBarcodeReady);

	DSScanner.addEventListener('onScannerReady', function () {
		console.log('HTML onScannerReady');
		var statusElement = document.getElementById('status');
		statusElement.innerHTML = ' ';	//statusElement.hidden = true;
		DSScanner.StartScanner();
	});

	DSScanner.Create(scannerSettings);
}

function OnResize() {
	document.getElementById('datasymbol-barcode-viewportDATASYMBOLVIDEOTAG').setAttribute('style', 'margin:0;padding:0');	//wp for unknown reasons changes style of video element (set height:0)
	//document.getElementById('datasymbol-barcode-viewportDATASYMBOLVIDEOTAG').style = 'margin:0;padding:0';	//wp for unknown reasons changes style of video element (set height:0)
}


window.onload = function () {
    /*    DSScanner.getVideoDevices(function (devices) {
            devices.forEach(function (device) {
                alert("device:" + device.label + '|' + device.id);
            });
        });
	*/

	window.addEventListener('resize', OnResize, false);

	CreateScanner();
}

